unit uRoboter;               {12.4.2002 Autor Pierre Schwieger}

{
Bitte Readme.txt lesen!
Mein Dank gilt
Herrn Ulrich Mller fr die umfish.dll und fr Aufnahme in seine Site.
Herrn Matthias Thoma und Herrn Uli Tessel fr die scanner.pas .
}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Spin, umFishEx;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Image1: TImage;
    ProgressBar1: TProgressBar;
    Edit2: TEdit;
    Edit3: TEdit;
    SpinEdit1: TSpinEdit;
    Image2: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Button4: TButton;
    Button7: TButton;
    Memo1: TMemo;
    Button11: TButton;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    Label4: TLabel;
    Label6: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Button11Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);

  private
    { Private-Deklarationen }
    procedure MyMsg(var Msg: TMsg; var Handled: Boolean);
    Procedure Farbwerte;
    Function Interface_da:Boolean;
    Procedure Anfangsposition;
    Procedure Interface_rauf_runter;
    Procedure Interface_links_rechts;
    Procedure Interface_vor_zurueck;
    Procedure aufmachen;
    Procedure greifezu;
    Procedure greifestift;
    Procedure AP_links_oben_zurueck;
    Procedure Auslesen;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  BMP1,BMP5,BMP6, BMP7: TBitmap;
  Color1:TColor;   {Farbwerte}
  filebmp,f:string;  {filebmp ist file.bmp ; f,ff sind Farbwert}
  ff,i,ii:Integer;{Schleifen global und lokal}
  j: Integer;{ Justierung an aus}
  posx,posy:Integer; {gefundene Koordinaten der Tonne siehe TonnX,TonneY}
  laenge:Integer;
  {...ab hier Var fr Roboter}
  rechts,vor:Integer;
  Port:String;         {com2}
  InterfaceIni:Integer;
  ist1,ist2,ist3,soll1,soll2,soll3:Integer; {Roboter ist und soll}
  {mit 1=recht/links 2=vor/zurck und 3=oben/unten}

  {ab hier Justierung Maus}
  MausJust:Integer;     {Schalter Mausjustierung ein 1 aus 0}
  Mausindex:Integer; {Mausjustierung Index 1..175 Werte}
  Mausxy :array [1..175,1..2] of Integer;   {Mausjust-werte 1=x,2=y}
  Speicher_gelesen: integer; {ist die Speicher.txt gelesen 1=ja}
  s1s2s3xy : array [1..175,1..5] of Integer; {Roboter zu Bild Koordinaten}
implementation                  {mit soll1,soll2,soll3,Mausx,Mausy}
uses
  Scanners;
const                          {     *       *        *           }
EMaske:array[1..8] of LongInt= ($1, $2, $4, $8, $10, $20, $40, $80);


{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin

  Image1.Stretch:=true;
  Application.OnMessage := MyMsg;
  TWOpenDSM(Application.Handle);
  filebmp:='c:\webcam.bmp';
  f:='175';
  farbwerte;

  j:=0; {schalter justierung}
  Form1.color:=clBtnFace;
  SpinEdit1Change(Sender);


Edit2.Text:=' ';
Edit3.Text:=' ';
Edit5.Text:=' ';
Edit6.Text:=' ';
Edit7.Text:=' ';

Memo1.Text:=' '; {Protokoll lschen}
InterfaceIni:=0; {das Interface wurde noch nicht gesucht und eingebunden}
MausJust:=0;

Speicher_gelesen:=0;
Auslesen;
end;


procedure TForm1.MyMsg(var Msg: TMsg; var Handled: Boolean);
begin
  Handled := ProcessSourceMessage(Msg);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Application.OnMessage := nil;
  if TWIsDSEnabled then
    TWDisableDS;
  if TWIsDSOpen then
    TWCloseDS;
  if TWIsDSMOpen then
    TWCloseDSM;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  TWSelectDS;
end;



Procedure TForm1.Farbwerte;
begin
ff:=strtoint(f);
case ff of

  	0 : Color1:=$00FfFfFf;   {Color1:=$00FFFFFF;   wei}
  	1 : Color1:=$00FeFeFe;
  	2 : Color1:=$00FdFdFd;
        3 : Color1:=$00FcFcFc;
        4 : Color1:=$00FbFbFb;
        5 : Color1:=$00FaFaFa;
        6 : Color1:=$00F9F9F9;
        7 : Color1:=$00F8F8F8;
        8 : Color1:=$00F7F7F7;
        9 : Color1:=$00F6F6F6;
        10 : Color1:=$00F5F5F5;
        11 : Color1:=$00F4F4F4;
        12 : Color1:=$00F3F3F3;
        13 : Color1:=$00F2F2F2;
        14 : Color1:=$00F1F1F1;
        15 : Color1:=$00F0F0F0;
        16: Color1:=$00efefef;
        17: Color1:=$00eeeeee;
        18: Color1:=$00ededed;
        19: Color1:=$00ececec;
        20: Color1:=$00ebebeb;
        21: Color1:=$00eaeaea;
        22: Color1:=$00e9e9e9;
        23: Color1:=$00e8e8e8;
        24: Color1:=$00e7e7e7;
        25: Color1:=$00e6e6e6;
        26: Color1:=$00e5e5e5;
        27: Color1:=$00e4e4e4;
        28: Color1:=$00e3e3e3;
        29: Color1:=$00e2e2e2;
        30: Color1:=$00e1e1e1;
        31: Color1:=$00e0e0e0;
32: Color1:=$00dfdfdf;
33: Color1:=$00dedede;
34: Color1:=$00dddddd;
35: Color1:=$00dcdcdc;
36: Color1:=$00dbdbdb;
37: Color1:=$00dadada;
38: Color1:=$00d9d9d9;
39: Color1:=$00d8d8d8;
40: Color1:=$00d7d7d7;
41: Color1:=$00d6d6d6;
42: Color1:=$00d5d5d5;
43: Color1:=$00d4d4d4;
44: Color1:=$00d3d3d3;
45: Color1:=$00d2d2d2;
46: Color1:=$00d1d1d1;
47: Color1:=$00d0d0d0;
48: Color1:=$00cfcfcf;
49: Color1:=$00cecece;
50: Color1:=$00cdcdcd;
51: Color1:=$00cccccc;
52: Color1:=$00cbcbcb;
53: Color1:=$00cacaca;
54: Color1:=$00c9c9c9;
55: Color1:=$00c8c8c8;
56: Color1:=$00c7c7c7;
57: Color1:=$00c6c6c6;
58: Color1:=$00c5c5c5;
59: Color1:=$00c4c4c4;
60: Color1:=$00c3c3c3;
61: Color1:=$00c2c2c2;
62: Color1:=$00c1c1c1;
63: Color1:=$00c0c0c0;
64: Color1:=$00bfbfbf;
65: Color1:=$00bebebe;
66: Color1:=$00bdbdbd;
67: Color1:=$00bcbcbc;
68: Color1:=$00bbbbbb;
69: Color1:=$00bababa;
70: Color1:=$00b9b9b9;
71: Color1:=$00b8b8b8;
72: Color1:=$00b7b7b7;
73: Color1:=$00b6b6b6;
74: Color1:=$00b5b5b5;
75: Color1:=$00b4b4b4;
76: Color1:=$00b3b3b3;
77: Color1:=$00b2b2b2;
78: Color1:=$00b1b1b1;
79: Color1:=$00b0b0b0;
80: Color1:=$00afafaf;
81: Color1:=$00aeaeae;
82: Color1:=$00adadad;
83: Color1:=$00acacac;
84: Color1:=$00ababab;
85: Color1:=$00aaaaaa;
86: Color1:=$00a9a9a9;
87: Color1:=$00a8a8a8;
88: Color1:=$00a7a7a7;
89: Color1:=$00a6a6a6;
90: Color1:=$00a5a5a5;
91: Color1:=$00a4a4a4;
92: Color1:=$00a3a3a3;
93: Color1:=$00a2a2a2;
94: Color1:=$00a1a1a1;
95: Color1:=$00a0a0a0;
96: Color1:=$009f9f9f;
97: Color1:=$009e9e9e;
98: Color1:=$009d9d9d;
99: Color1:=$009c9c9c;
100: Color1:=$009b9b9b;
101: Color1:=$009a9a9a;
102: Color1:=$00999999;
103: Color1:=$00989898;
104: Color1:=$00979797;
105: Color1:=$00969696;
106: Color1:=$00959595;
107: Color1:=$00949494;
108: Color1:=$00939393;
109: Color1:=$00929292;
110: Color1:=$00919191;
111: Color1:=$00909090;
112: Color1:=$008f8f8f;
113: Color1:=$008e8e8e;
114: Color1:=$008d8d8d;
115: Color1:=$008c8c8c;
116: Color1:=$008b8b8b;
117: Color1:=$008a8a8a;
118: Color1:=$00898989;
119: Color1:=$00888888;
120: Color1:=$00878787;
121: Color1:=$00868686;
122: Color1:=$00858585;
123: Color1:=$00848484;
124: Color1:=$00838383;
125: Color1:=$00828282;
126: Color1:=$00818181;
127: Color1:=$00808080;
128: Color1:=$007f7f7f;
129: Color1:=$007e7e7e;
130: Color1:=$007d7d7d;
131: Color1:=$007c7c7c;
132: Color1:=$007b7b7b;
133: Color1:=$007a7a7a;
134: Color1:=$00797979;
135: Color1:=$00787878;
136: Color1:=$00777777;
137: Color1:=$00767676;
138: Color1:=$00757575;
139: Color1:=$00747474;
140: Color1:=$00737373;
141: Color1:=$00727272;
142: Color1:=$00717171;
143: Color1:=$00707070;
144: Color1:=$006f6f6f;
145: Color1:=$006e6e6e;
146: Color1:=$006d6d6d;
147: Color1:=$006c6c6c;
148: Color1:=$006b6b6b;
149: Color1:=$006a6a6a;
150: Color1:=$00696969;
151: Color1:=$00686868;
152: Color1:=$00676767;
153: Color1:=$00666666;
154: Color1:=$00656565;
155: Color1:=$00646464;
156: Color1:=$00636363;
157: Color1:=$00626262;
158: Color1:=$00616161;
159: Color1:=$00606060;
160: Color1:=$005f5f5f;
161: Color1:=$005e5e5e;
162: Color1:=$005d5d5d;
163: Color1:=$005c5c5c;
164: Color1:=$005b5b5b;
165: Color1:=$005a5a5a;
166: Color1:=$00595959;
167: Color1:=$00585858;
168: Color1:=$00575757;
169: Color1:=$00565656;
170: Color1:=$00555555;
171: Color1:=$00545454;
172: Color1:=$00535353;
173: Color1:=$00525252;
174: Color1:=$00515151;
175: Color1:=$00505050;
176: Color1:=$004f4f4f;
177: Color1:=$004e4e4e;
178: Color1:=$004d4d4d;
179: Color1:=$004c4c4c;
180: Color1:=$004b4b4b;
181: Color1:=$004a4a4a;
182: Color1:=$00494949;
183: Color1:=$00484848;
184: Color1:=$00474747;
185: Color1:=$00464646;
186: Color1:=$00454545;
187: Color1:=$00444444;
188: Color1:=$00434343;
189: Color1:=$00424242;
190: Color1:=$00414141;
191: Color1:=$00404040;
192: Color1:=$003f3f3f;
193: Color1:=$003e3e3e;
194: Color1:=$003d3d3d;
195: Color1:=$003c3c3c;
196: Color1:=$003b3b3b;
197: Color1:=$003a3a3a;
198: Color1:=$00393939;
199: Color1:=$00383838;
200: Color1:=$00373737;
201: Color1:=$00363636;
202: Color1:=$00353535;
203: Color1:=$00343434;
204: Color1:=$00333333;
205: Color1:=$00323232;
206: Color1:=$00313131;
207: Color1:=$00303030;
208: Color1:=$002f2f2f;
209: Color1:=$002e2e2e;
210: Color1:=$002d2d2d;
211: Color1:=$002c2c2c;
212: Color1:=$002b2b2b;
213: Color1:=$002a2a2a;
214: Color1:=$00292929;
215: Color1:=$00282828;
216: Color1:=$00272727;
217: Color1:=$00262626;
218: Color1:=$00252525;
219: Color1:=$00242424;
220: Color1:=$00232323;
221: Color1:=$00222222;
222: Color1:=$00212121;
223: Color1:=$00202020;
{ab hier nicht mehr fortlaufend}
224: Color1:=$00101010;
225: Color1:=$00000000;

end;

end;


procedure TForm1.Button1Click(Sender: TObject);
var
  StartTime: DWORD;
begin
ProgressBar1.Position := 0;

memo1.lines.add('bitte warten!');
if FileExists('c:\webcam0.bmp') then DeleteFile('c:\webcam0.bmp');

TWAcquire(Application.Handle, Image1.Picture.Bitmap, true);

StartTime := GetTickCount();
  while (GetTickCount - StartTime < 5000) do
    Application.ProcessMessages;
memo1.lines.add('Foto ist aufgenommen');

repeat until  FileExists('c:\webcam0.bmp');

If j=1 then              
begin
if FileExists('c:\just.bmp') then DeleteFile('c:\just.bmp');
RenameFile('c:\webcam0.bmp','c:\just.bmp');
memo1.lines.add('Justierung beendet');
memo1.lines.add('c:\just.bmp');
end;

If j=0 then
begin
if FileExists('c:\webcam.bmp') then DeleteFile('c:\webcam.bmp');
RenameFile('c:\webcam0.bmp','c:\webcam.bmp');
memo1.lines.add('c:\webcam.bmp');
end;

ProgressBar1.Position := 240;
memo1.lines.add('jetzt kann es weitergehen!');
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
f:=SpinEdit1.Text;
Farbwerte;
BMP1:=TBitmap.Create;
with BMP1 do
begin
Height := 30;
Width := 60;
with Canvas do begin
Brush.Color := color1;
FillRect(Rect(0, 0, 60, 15));
Brush.Color := $00FfFfFf;
FillRect(Rect(0, 15, 60, 30));
Image2.Picture.Graphic:=BMP1;
end;
end;
BMP1.free;
end;


 {..................................}
 {..................................}
 {..................................}
procedure TForm1.Button4Click(Sender: TObject);

begin    {Justierung an j=1}
j := 1;
Button1Click(Sender);
j := 0;
begin




end;

Form1.color:=clBtnFace;
end;



procedure TForm1.Button7Click(Sender: TObject);   {VERGLEICH}
var
i,ii:Integer;{For Schleife}
zzz:Integer; { zzz= gefundene Punkte}
TonneX,TonneY:Integer; {position der Tonne}
Steigung:Integer;       {Steigung der blauen Linie}
posXmin,posXmax,posYmin,posYmax :Integer;    {finde nahen Wert}
begin

BMP5:=TBitmap.Create;
BMP5.height:=240;         {Justierung}
BMP5.width:=320;
BMP6:=TBitmap.Create;
BMP6.height:=240;          {Foto}
BMP6.width:=320;

zzz:=0;
posXmin:=320;
posXmax:=-1;
posYmin:=240;
posYmax:=-1;

If FileExists('c:\just.bmp') then 
     begin
     BMP5.LoadFromFile('c:\just.bmp');
     Image1.Picture.Graphic:=BMP5;
     end;
If FileExists('c:\webcam.bmp') then BMP6.LoadFromFile('c:\webcam.bmp');



for i:=45 to 235 do
    begin
    ProgressBar1.Position := i;
    for ii:= 30 to 263 do
    begin
    
         If (BMP5.Canvas.Pixels [ii,i] - BMP6.Canvas.Pixels [ii,i]) > color1 then
         begin
         BMP6.Canvas.Pixels [ii,i]:=clYellow;
         Inc(zzz);
         if posXmin > ii then posXmin := ii;
         if posXmax < ii then posXmax := ii;
         if posYmin > i then posYmin := i;
         if posYmax < i then posYmax := i;

         {...}
         end;
    end;
end;

{.....}
if (posXmax > -1 ) and (posYmax > -1) then
begin
BMP6.Canvas.Pixels [trunc ((posXmin+posXmax)/2),trunc ((posYmin+posYmax)/2)]:=clred;
BMP6.Canvas.Pixels [trunc ((posXmin+posXmax)/2)+1,trunc ((posYmin+posYmax)/2)]:=clred;
BMP6.Canvas.Pixels [trunc ((posXmin+posXmax)/2),trunc ((posYmin+posYmax)/2)+1]:=clred;
BMP6.Canvas.Pixels [trunc ((posXmin+posXmax)/2)+1,trunc ((posYmin+posYmax)/2)+1]:=clred;
Edit3.Text:=inttostr(trunc ((posXmin+posXmax)/2))+' , '+inttostr(trunc ((posYmin+posYmax)/2));
TonneX:=trunc ((posXmin+posXmax)/2);
TonneY:=trunc ((posYmin+posYmax)/2);
end
else Edit3.Text:='nichts gefunden';

{.....}
{Steigung}
BMP6.Canvas.Pen.Color := clBlue;
BMP6.Canvas.MoveTo(TonneX, TonneY);
if TonneX=160 then TonneX:=161; {kein null Problem}
Steigung:=trunc(-(0-TonneY)/(160-TonneX)*10);

if Steigung=0 then Steigung:=1; {kein null Problem}
BMP6.Canvas.LineTo(trunc(130-110/Steigung), 0);

{Die Steigung berechnet sich mit Punkten auerhalb des Bildes!}
BMP6.Canvas.Textout(165,2,'Steigung ='+inttostr(Steigung));

{........}

Image1.Picture.Graphic:=BMP6;
ProgressBar1.Position := 0;
Form1.color:=clBtnFace;

Edit2.Text:=inttostr(zzz);

BMP5.free;
BMP6.free;

posx:=TonneX;
posY:=TonneY;


end;



{MausMausMausMausMausMausMausMausMausMausMausMausMausMausMausMausMausMausMaus}
{MausMausMausMausMausMausMausMausMausMausMausMausMausMausMausMausMausMausMaus}
{MausMausMausMausMausMausMausMausMausMausMausMausMausMausMausMausMausMausMaus}
{MausMausMausMausMausMausMausMausMausMausMausMausMausMausMausMausMausMausMaus}
{MausMausMausMausMausMausMausMausMausMausMausMausMausMausMausMausMausMausMaus}


procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
 Shift: TShiftState; X, Y: Integer);
 var
steigung2,realeSt:Integer;   {Steigung der Linie}

an:Integer; {Angleichung lineto wert}

al:real; {Ausgleich Lnge}
{ab hier Mausjustierung}

neuerSpeicher : array [1..175,1..5] of Integer;
Speicher1Zeile,Speicher2Zeile:string;
f: Textfile;
Stelle:Integer;
Zahl1,Zahl2,Zahl3,Zahl4,Zahl5:Integer;
Zeile1,Zeile2,Zeile3,Zeile4,Zeile5,Zeile6:String;
Index:Integer;
ab,ab1:real;
GanzeZeile:String;
sp1,sp2,sp:Integer;
i:Integer;{For Schleife}


begin
if Button = mbright then begin
posx:=x;
posy:=Y;
memo1.lines.add('Maus:('+inttostr(posx)+','+inttostr(posy)+')');


BMP7:=TBitmap.Create;
BMP7.height:=240;          {Foto}
BMP7.width:=320;

If FileExists('c:\webcam.bmp') then
begin
BMP7.LoadFromFile('c:\webcam.bmp');
Image1.Picture.Graphic:=BMP7;
end;

{Steigung}
BMP7.Canvas.Pen.Color := clBlue;   {blaue Linie}
BMP7.Canvas.MoveTo(posX, posY);   {blaue Linie}
if posx = 130 then posx:=131; {kein durch null Problem}
Steigung2:=trunc(-(0-PosY)/(130-posX)*10);
if Steigung2 = 0 Then Steigung2:=1;   {kein durch null Problem}

{Angleichung fr blaue Linie, Steigung2 jetzt auch fr die Linie}
an:=trunc(130-330/Steigung2);
  edit2.text:=inttostr(an);
{reale Steigung}
if posx = 40 then posx:=41;
 realeSt:=trunc(-(40-PosY)/(130-posX)*100);



{.........}


If an < 60 then an:=60;
If an > 210 then an:=210;
edit3.text:=inttostr(an);
BMP7.Canvas.LineTo(an, 0);    {blaue Linie}


  {Lnge .....................mit 197Punkten zu 93mm.}
If posx<130 then al:=(130-posx)*0.0851;
If posx>129 then al:=(130-posx)*0.075;
Laenge:= trunc( (sqrt(abs( sqr(130-posx)+sqr(-110-posy) ))-45)/197*93+al );
{Die Steigung berechnet sich mit Punkten auerhalb des Bildes!}
BMP7.Canvas.Textout(an+trunc(an/12),2,'St.='+inttostr(realeST)+'; L.:'+inttostr(Laenge)+'mm');





{.............}
ab1:=100; {max wert zu unterschreiten}
For index:=1 to 175 do
begin
ab:=sqrt(sqr(s1s2s3xy[Index,4]-posx)+sqr(s1s2s3xy[index,5]-posy));
if ab<ab1 then
begin
ab1:=ab;
sp1:=s1s2s3xy[Index,4];
sp2:=s1s2s3xy[Index,5];
end;
BMP7.Canvas.Pixels [s1s2s3xy[Index,4],s1s2s3xy[Index,5]]:=clgreen;
BMP7.Canvas.Pixels [s1s2s3xy[Index,4]+1,s1s2s3xy[Index,5]+1]:=clgreen;
BMP7.Canvas.Pixels [s1s2s3xy[Index,4]+1,s1s2s3xy[Index,5]]:=clgreen;
BMP7.Canvas.Pixels [s1s2s3xy[Index,4],s1s2s3xy[Index,5]+1]:=clgreen;

end;
BMP7.Canvas.Pixels [sp1,sp2]:=clred;
BMP7.Canvas.Pixels [sp1+1,sp2+1]:=clred;
BMP7.Canvas.Pixels [sp1+1,sp2]:=clred;
BMP7.Canvas.Pixels [sp1,sp2+1]:=clred;



{.............}
Image1.Picture.Graphic:=BMP7;
end; {ENDE von rechter Maustaste}

if (Button = mbleft) and  (MausJust=1)then
begin
inc(Mausindex);

If MausXY[Mausindex,1]=0 then Mausxy[Mausindex,1]:=x;
If MausXY[Mausindex,2]=0 then Mausxy[Mausindex,2]:=y;
memo1.lines.add(inttostr(MausIndex)+'.Punkt bei ('+inttostr(x)+','+inttostr(y)+')');

if Mausindex > 174 then
begin
MausJust:=0;
memo1.lines.add('Mausjustierung erledigt');
memo1.lines.add('Speichere Daten zu Speicher.txt');

MausIndex:=0;
AssignFile(f, ExtractFilePath(Application.Exename) + 'speicher.txt');
reset(f);
Readln(f, Speicher1Zeile);
repeat
Inc(MausIndex);
Readln(f, Speicher1Zeile);
Stelle:=Pos(':',Speicher1Zeile);
Speicher2Zeile:=copy(Speicher1Zeile,Stelle+1,length(Speicher1Zeile));
Stelle:=Pos(';',Speicher2Zeile);
Speicher1Zeile:=copy(Speicher2Zeile,1,Stelle-1);
neuerSpeicher[Mausindex,1]:=strtoint(Speicher1Zeile);
Speicher1Zeile:=copy(Speicher2Zeile,Stelle+1,length(Speicher2Zeile));
Stelle:=Pos(';',Speicher1Zeile);
Speicher2Zeile:=copy(Speicher1Zeile,1,Stelle-1);
neuerSpeicher[Mausindex,2]:=strtoint(Speicher2Zeile);
Speicher2Zeile:=copy(Speicher1Zeile,Stelle+1,length(Speicher1Zeile));
Stelle:=Pos(';',Speicher2Zeile);
Speicher1Zeile:=copy(Speicher2Zeile,1,Stelle-1);
neuerSpeicher[Mausindex,3]:=strtoint(Speicher1Zeile);
neuerSpeicher[Mausindex,4]:=Mausxy[Mausindex,1];
neuerSpeicher[Mausindex,5]:=Mausxy[Mausindex,2];
until MausIndex > 174; {eof(f)}
closefile(f);

 {....................}
AssignFile(f,  ExtractFilePath(Application.Exename) +'Speicher.txt');
Append(f);
writeln(f,'Roboter-Postionen (Nr:Soll1[rechts];Soll2[vor];Soll3[oben];x;y;)');
for Index := 1 to 175 do
begin
Zahl1:=neuerSpeicher[Index,1];
Zahl2:=neuerSpeicher[Index,2];
Zahl3:=neuerSpeicher[Index,3];
Zahl4:=neuerSpeicher[Index,4];
Zahl5:=neuerSpeicher[Index,5];
Zeile1:=inttostr(Zahl1)+';';
Zeile2:=inttostr(Zahl2)+';';
Zeile3:=inttostr(Zahl3)+';';
Zeile4:=inttostr(Zahl4)+';';
Zeile5:=inttostr(Zahl5)+';';
Zeile6:=inttostr(Index)+':';
GanzeZeile:=Zeile6+Zeile1+Zeile2+Zeile3+Zeile4+Zeile5;
writeln(f,GanzeZeile);
end;
closefile(f);
memo1.lines.add('ist erledigt!');
BMP7.free;


end;

end; {ENDE von linker Maustaste}
end;

procedure TForm1.Button14Click(Sender: TObject); {Mausjustierung an/aus}
var
i:Integer; {For Schleife}
begin

if MausJust =0 then
begin
MausJust:=1;
Mausindex:=0;
memo1.lines.add('Mausjustierung an');
memo1.lines.add('Index auf null!');
For I :=1 to 175 do
begin
MausXY[I,1]:=0;
MausXY[I,2]:=0;
end;

end
else
begin
Mausjust:=0;
memo1.lines.add('Mausjustierung aus');
end;

end;



Procedure TForm1.aufmachen;
begin
if ftiGetInput (7) then
   begin
   ftiSetMotor(4, ftiAus);
   memo1.lines.add('Zange ist auf');
   end;
If not ftiGetInput (7) then
begin
ftiSetMotor(4, ftilinks);
memo1.lines.add('mache Zange auf');
ftiWaitForInput(7,true); {warte bis S7 geschaltet}
ftiSetMotor(4, ftiAus);
memo1.lines.add('Zange ist auf');
end;
end;
 {....................................................}



procedure TForm1.Interface_vor_zurueck;
var
  j_:           Byte;
  f_, o_:           Boolean;
  p_, diff: Integer;

procedure reale_Abfrage2;

var i_: Cardinal; iStatus: LongInt;
begin
  iStatus := ftiGetInputs;    // --- um wiederholten Interfacezugriff zu vermeiden
  for i_ := 1 to 3 do begin
    if (iStatus AND EMaske[4] = 0) then f_:= false else f_ := true;
    if o_ <> f_ then Inc(p_);
    o_ := f_;
      Edit7.text:=inttostr(ist2);
    end;
end;

begin
    f_    := false;
    o_    := false;
    p_    := 0;
    diff := 0;
    if soll2 < ist2 then ftiSetMotor(2, ftiLinks)
    else if soll2 > ist2 then ftiSetMotor(2, ftiRechts);

  repeat
    reale_Abfrage2;

      if soll2 > ist2 then
      begin
      diff := soll2 - (ist2 + p_); Edit7.text:=inttostr(ist2+p_);
      end;
      if soll2 < ist2 then
      begin
      diff := ist2 - (soll2 + p_);Edit7.text:=inttostr(ist2-p_);
      end;
      if (diff = 0) then ftiSetMotor(2, ftiAus);

  until (diff <= 0);
  for j_ := 1 to 20 do reale_Abfrage2;
      if soll2 > ist2 then
      begin Inc(ist2, p_);Edit7.text:=inttostr(ist2);end
    else if soll2 < ist2 then
    begin Dec(ist2, p_);Edit7.text:=inttostr(ist2);end
end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::}

procedure TForm1.Interface_links_rechts; {rechts/links}
var
  j_:           Byte;
  f_, o_:           Boolean;
  p_, diff: Integer;

procedure reale_Abfrage1;

var i_: Cardinal; iStatus: LongInt;
begin
  iStatus := ftiGetInputs;    // --- um wiederholten Interfacezugriff zu vermeiden
  for i_ := 1 to 3 do begin
    if (iStatus AND EMaske[2] = 0) then f_:= false else f_ := true;
    if o_ <> f_ then Inc(p_);
    o_ := f_;
      Edit6.text:=inttostr(ist1);
    end;
end;

begin
    f_    := false;
    o_    := false;
    p_    := 0;
    diff := 0;
    if soll1 < ist1 then ftiSetMotor(1, ftiLinks)
    else if soll1 > ist1 then ftiSetMotor(1, ftiRechts);

  repeat
    reale_Abfrage1;

      if soll1 > ist1 then
      begin
      diff := soll1 - (ist1 + p_); Edit6.text:=inttostr(ist1+p_);
      end;
      if soll1 < ist1 then
      begin
      diff := ist1 - (soll1 + p_);Edit6.text:=inttostr(ist1-p_);
      end;
      if (diff = 0) then ftiSetMotor(1, ftiAus);

  until (diff <= 0);
  for j_ := 1 to 20 do reale_Abfrage1;
      if soll1 > ist1 then
      begin Inc(ist1, p_);Edit6.text:=inttostr(ist1);end
    else if soll1 < ist1 then
    begin Dec(ist1, p_);Edit6.text:=inttostr(ist1);end
end;


{..................................}
procedure TForm1.Interface_rauf_runter;
var
  j_:           Byte;
  f_, o_:           Boolean;
  p_, diff: Integer;

procedure reale_Abfrage;

var i_: Cardinal; iStatus: LongInt;
begin
  iStatus := ftiGetInputs;    // --- um wiederholten Interfacezugriff zu vermeiden
  for i_ := 1 to 3 do begin
    if (iStatus AND EMaske[6] = 0) then f_:= false else f_ := true;
    if o_ <> f_ then Inc(p_);
    o_ := f_;
      Edit5.text:=inttostr(ist3);
    end;
end;

begin
    f_    := false;
    o_    := false;
    p_    := 0;
    diff := 0;
    if soll3 < ist3 then ftiSetMotor(3, ftiLinks)
    else if soll3 > ist3 then ftiSetMotor(3, ftiRechts);

  repeat
    reale_Abfrage;

      if soll3 > ist3 then
      begin
      diff := soll3 - (ist3 + p_); Edit5.text:=inttostr(ist3+p_);
      end;
      if soll3 < ist3 then
      begin
      diff := ist3 - (soll3 + p_);Edit5.text:=inttostr(ist3-p_);
      end;
      if (diff = 0) then ftiSetMotor(3, ftiAus);

  until (diff <= 0);
  for j_ := 1 to 20 do reale_Abfrage;
      if soll3 > ist3 then
      begin Inc(ist3, p_);Edit5.text:=inttostr(ist3);end
    else if soll3 < ist3 then
    begin Dec(ist3, p_);;Edit5.text:=inttostr(ist3);end;
end;



Function TForm1.Interface_da:Boolean;
begin
Port:='com2';
If ftiOpenInterface(Port)=ftiFehler then
begin
Result:=false;
MessageDlg('Kein Interface an COM2 gefunden!',mtInformation, [mbOK],0);
exit;
end;
Result:=true;
memo1.lines.add('Interface an COM2');
Interfaceini:=1;
end;


Procedure TForm1.Anfangsposition;      {simultan!}
var
s1,s3,s5,s7,sch1,sch2,sch3,sch4 : Integer;
begin
s1:=0;  {Schalter Anschlag Linksdrehung des Arms}
s3:=0;  {Schalter Anschlag Hochfahren des Arms}
s5:=0;  {Schalter Anschalg Reinfahren des Arms}
s7:=0;  {Schalter Anschlag ffnung der Zange}
sch1:=1;   {Text im Protokoll nur einmal darstellen}
sch2:=1;   {Text im Protokoll nur einmal darstellen}
sch3:=1;{Text im Protokoll nur einmal darstellen}
sch4:=1;{Text im Protokoll nur einmal darstellen}

repeat {links}
if ftiGetInput (1) then
   begin
   ftiSetMotor(1, ftiAus);
   S1:=1;
   if sch1=1 then memo1.lines.add('Anschlag Links');
   sch1:=0;
   end;
If s1=0 then ftiSetMotor(1, ftilinks);
 {zurck}
if ftiGetInput (3) then
   begin
   ftiSetMotor(2, ftiAus);
   S3:=1;
 if sch2=1 then memo1.lines.add('Anschlag hinten');
   sch2:=0;
   end;
If s3=0 then ftiSetMotor(2, ftilinks);
   {oben}
if ftiGetInput (5) then
   begin
   ftiSetMotor(3, ftiAus);
   S5:=1;
  if sch3=1 then  memo1.lines.add('Anschlag oben');
  sch3:=0;
   end;
If s5=0 then ftiSetMotor(3, ftilinks);
{auf}
if ftiGetInput (7) then
   begin
   ftiSetMotor(4, ftiAus);
   S7:=1;
    if sch4=1 then memo1.lines.add('Zange ist auf');
   sch4:=0;
   end;
If s7=0 then ftiSetMotor(4, ftilinks);
until (s7=1) and (s5=1) and (s3=1) and (s1=1);
ist1 :=0;
soll1:=0;
ist2 :=0;
soll2:=0;
ist3 :=0;
soll3:=0;
memo1.lines.add('Anfangsposition');
Edit5.Text:='0';
Edit6.Text:='0';
Edit7.Text:='0';
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
If InterfaceIni =0 then Interface_da;
Anfangsposition;
soll1:=0;
soll2:=0;
soll3:=0;
end;

procedure TForm1.Button13Click(Sender: TObject);   {Roboterjustierung}
var
d:Integer;

Zeile1,zeile2,Zeile3,Zeile4:String;
GanzeZeile:String;
Speicher: array[1..175,1..3] of Integer;
index:Integer;          {Speicher Index}
 f: Textfile;
begin
index:=0;
Memo1.Text:=' ';
memo1.lines.add(' ');
memo1.lines.add(' ');
memo1.lines.add(' ');
memo1.lines.add(' ');
memo1.lines.add(' ');
memo1.lines.add(' ');
memo1.lines.add(' ');
If InterfaceIni =0 then Interface_da;
AP_links_oben_zurueck;
greifeStift;
{.............}

soll1:=70;
memo1.lines.add('fahre rechts auf '+inttostr(soll1));
Interface_links_rechts;

for d:= 1 to 13 do begin

soll3:=50;
memo1.lines.add('fahre runter auf '+inttostr(soll2));
Interface_rauf_runter;
inc(Index);
Speicher[index,1]:=Soll1;  {rechts}
Speicher[index,2]:=Soll2;  {vor}
Speicher[index,3]:=Soll3;  {oben}


soll3:=40;
memo1.lines.add('fahre hoch '+inttostr(soll3));
Interface_rauf_runter;

soll1:=70+(5*d);
memo1.lines.add('fahre rechts auf '+inttostr(soll1));
Interface_links_rechts;
end;

soll3:=50;
memo1.lines.add('fahre runter auf '+inttostr(soll2));
Interface_rauf_runter;
inc(Index);
Speicher[index,1]:=Soll1;  {rechts}
Speicher[index,2]:=Soll2;  {vor}
Speicher[index,3]:=Soll3;  {oben}

soll3:=20;
memo1.lines.add('fahre hoch '+inttostr(soll3));
Interface_rauf_runter;

AP_links_oben_zurueck;


soll2:=20;
memo1.lines.add('fahre vor auf '+inttostr(soll2));
Interface_vor_zurueck;

soll1:=65;
memo1.lines.add('fahre rechts auf '+inttostr(soll1));
Interface_links_rechts;

for d:= 1 to 18 do begin

soll3:=50;
memo1.lines.add('fahre runter auf '+inttostr(soll2));
Interface_rauf_runter;
inc(Index);
Speicher[index,1]:=Soll1;  {rechts}
Speicher[index,2]:=Soll2;  {vor}
Speicher[index,3]:=Soll3;  {oben}

soll3:=40;
memo1.lines.add('fahre hoch '+inttostr(soll3));
Interface_rauf_runter;

soll1:=65+(5*d);
memo1.lines.add('fahre rechts auf '+inttostr(soll1));
Interface_links_rechts;
end;

soll3:=50;
memo1.lines.add('fahre runter auf '+inttostr(soll2));
Interface_rauf_runter;
inc(Index);
Speicher[index,1]:=Soll1;  {rechts}
Speicher[index,2]:=Soll2;  {vor}
Speicher[index,3]:=Soll3;  {oben}

soll3:=20;
memo1.lines.add('fahre hoch '+inttostr(soll3));
Interface_rauf_runter;



AP_links_oben_zurueck;

soll2:=40;
memo1.lines.add('fahre vor auf '+inttostr(soll2));
Interface_vor_zurueck;

soll1:=65;
memo1.lines.add('fahre rechts auf '+inttostr(soll1));
Interface_links_rechts;

for d:= 1 to 19 do begin

soll3:=50;
memo1.lines.add('fahre runter auf '+inttostr(soll2));
Interface_rauf_runter;
inc(Index);
Speicher[index,1]:=Soll1;  {rechts}
Speicher[index,2]:=Soll2;  {vor}
Speicher[index,3]:=Soll3;  {oben}

soll3:=40;
memo1.lines.add('fahre hoch '+inttostr(soll3));
Interface_rauf_runter;

soll1:=65+(5*d);
memo1.lines.add('fahre rechts auf '+inttostr(soll1));
Interface_links_rechts;
end;

soll3:=50;
memo1.lines.add('fahre runter auf '+inttostr(soll2));
Interface_rauf_runter;
inc(Index);
Speicher[index,1]:=Soll1;  {rechts}
Speicher[index,2]:=Soll2;  {vor}
Speicher[index,3]:=Soll3;  {oben}

soll3:=20;
memo1.lines.add('fahre hoch '+inttostr(soll3));
Interface_rauf_runter;

AP_links_oben_zurueck;

soll2:=60;
memo1.lines.add('fahre vor auf '+inttostr(soll2));
Interface_vor_zurueck;

soll1:=70;
memo1.lines.add('fahre rechts auf '+inttostr(soll1));
Interface_links_rechts;

for d:= 1 to 20 do begin

soll3:=50;
memo1.lines.add('fahre runter auf '+inttostr(soll2));
Interface_rauf_runter;
inc(Index);
Speicher[index,1]:=Soll1;  {rechts}
Speicher[index,2]:=Soll2;  {vor}
Speicher[index,3]:=Soll3;  {oben}

soll3:=40;
memo1.lines.add('fahre hoch '+inttostr(soll3));
Interface_rauf_runter;

soll1:=70+(5*d);
memo1.lines.add('fahre rechts auf '+inttostr(soll1));
Interface_links_rechts;
end;

soll3:=50;
memo1.lines.add('fahre runter auf '+inttostr(soll2));
Interface_rauf_runter;
inc(Index);
Speicher[index,1]:=Soll1;  {rechts}
Speicher[index,2]:=Soll2;  {vor}
Speicher[index,3]:=Soll3;  {oben}

soll3:=20;
memo1.lines.add('fahre hoch '+inttostr(soll3));
Interface_rauf_runter;

AP_links_oben_zurueck;

soll2:=80;
memo1.lines.add('fahre vor auf '+inttostr(soll2));
Interface_vor_zurueck;

soll1:=70;
memo1.lines.add('fahre rechts auf '+inttostr(soll1));
Interface_links_rechts;

for d:= 1 to 21 do begin

soll3:=50;
memo1.lines.add('fahre runter auf '+inttostr(soll2));
Interface_rauf_runter;
inc(Index);
Speicher[index,1]:=Soll1;  {rechts}
Speicher[index,2]:=Soll2;  {vor}
Speicher[index,3]:=Soll3;  {oben}

soll3:=40;
memo1.lines.add('fahre hoch '+inttostr(soll3));
Interface_rauf_runter;

soll1:=70+(5*d);
memo1.lines.add('fahre rechts auf '+inttostr(soll1));
Interface_links_rechts;
end;

soll3:=50;
memo1.lines.add('fahre runter auf '+inttostr(soll2));
Interface_rauf_runter;
inc(Index);
Speicher[index,1]:=Soll1;  {rechts}
Speicher[index,2]:=Soll2;  {vor}
Speicher[index,3]:=Soll3;  {oben}

soll3:=20;
memo1.lines.add('fahre hoch '+inttostr(soll3));
Interface_rauf_runter;

AP_links_oben_zurueck;


soll2:=100;
memo1.lines.add('fahre vor auf '+inttostr(soll2));
Interface_vor_zurueck;

soll1:=75;
memo1.lines.add('fahre rechts auf '+inttostr(soll1));
Interface_links_rechts;

for d:= 1 to 20 do begin

soll3:=49;
memo1.lines.add('fahre runter auf '+inttostr(soll2));
Interface_rauf_runter;
inc(Index);
Speicher[index,1]:=Soll1;  {rechts}
Speicher[index,2]:=Soll2;  {vor}
Speicher[index,3]:=Soll3;  {oben}

soll3:=40;
memo1.lines.add('fahre hoch '+inttostr(soll3));
Interface_rauf_runter;

soll1:=75+(5*d);
memo1.lines.add('fahre rechts auf '+inttostr(soll1));
Interface_links_rechts;
end;

soll3:=49;
memo1.lines.add('fahre runter auf '+inttostr(soll2));
Interface_rauf_runter;
inc(Index);
Speicher[index,1]:=Soll1;  {rechts}
Speicher[index,2]:=Soll2;  {vor}
Speicher[index,3]:=Soll3;  {oben}

soll3:=20;
memo1.lines.add('fahre hoch '+inttostr(soll3));
Interface_rauf_runter;

AP_links_oben_zurueck;

soll2:=120;
memo1.lines.add('fahre vor auf '+inttostr(soll2));
Interface_vor_zurueck;

soll1:=77;
memo1.lines.add('fahre rechts auf '+inttostr(soll1));
Interface_links_rechts;

for d:= 1 to 19 do begin

soll3:=46;
memo1.lines.add('fahre runter auf '+inttostr(soll2));
Interface_rauf_runter;
inc(Index);
Speicher[index,1]:=Soll1;  {rechts}
Speicher[index,2]:=Soll2;  {vor}
Speicher[index,3]:=Soll3;  {oben}

soll3:=34;
memo1.lines.add('fahre hoch '+inttostr(soll3));
Interface_rauf_runter;

soll1:=75+(5*d);
memo1.lines.add('fahre rechts auf '+inttostr(soll1));
Interface_links_rechts;
end;

soll3:=46;
memo1.lines.add('fahre runter auf '+inttostr(soll2));
Interface_rauf_runter;
inc(Index);
Speicher[index,1]:=Soll1;  {rechts}
Speicher[index,2]:=Soll2;  {vor}
Speicher[index,3]:=Soll3;  {oben}

soll3:=20;
memo1.lines.add('fahre hoch '+inttostr(soll3));
Interface_rauf_runter;

AP_links_oben_zurueck;

soll2:=140;
memo1.lines.add('fahre vor auf '+inttostr(soll2));
Interface_vor_zurueck;

soll1:=78;
memo1.lines.add('fahre rechts auf '+inttostr(soll1));
Interface_links_rechts;

for d:= 1 to 18 do begin

soll3:=40;
memo1.lines.add('fahre runter auf '+inttostr(soll2));
Interface_rauf_runter;
inc(Index);
Speicher[index,1]:=Soll1;  {rechts}
Speicher[index,2]:=Soll2;  {vor}
Speicher[index,3]:=Soll3;  {oben}

soll3:=32;
memo1.lines.add('fahre hoch '+inttostr(soll3));
Interface_rauf_runter;

soll1:=80+(5*d);
memo1.lines.add('fahre rechts auf '+inttostr(soll1));
Interface_links_rechts;
end;

soll3:=40;
memo1.lines.add('fahre runter auf '+inttostr(soll2));
Interface_rauf_runter;
inc(Index);
Speicher[index,1]:=Soll1;  {rechts}
Speicher[index,2]:=Soll2;  {vor}
Speicher[index,3]:=Soll3;  {oben}

soll3:=20;
memo1.lines.add('fahre hoch '+inttostr(soll3));
Interface_rauf_runter;

AP_links_oben_zurueck;

soll2:=160;
memo1.lines.add('fahre vor auf '+inttostr(soll2));
Interface_vor_zurueck;

soll1:=80;
memo1.lines.add('fahre rechts auf '+inttostr(soll1));
Interface_links_rechts;

for d:= 1 to 18 do begin

soll3:=35;
memo1.lines.add('fahre runter auf '+inttostr(soll2));
Interface_rauf_runter;
inc(Index);
Speicher[index,1]:=Soll1;  {rechts}
Speicher[index,2]:=Soll2;  {vor}
Speicher[index,3]:=Soll3;  {oben}

soll3:=26;
memo1.lines.add('fahre hoch '+inttostr(soll3));
Interface_rauf_runter;

soll1:=80+(5*d);
memo1.lines.add('fahre rechts auf '+inttostr(soll1));
Interface_links_rechts;
end;

soll3:=35;
memo1.lines.add('fahre runter auf '+inttostr(soll2));
Interface_rauf_runter;
inc(Index);
Speicher[index,1]:=Soll1;  {rechts}
Speicher[index,2]:=Soll2;  {vor}
Speicher[index,3]:=Soll3;  {oben}

soll3:=15;
memo1.lines.add('fahre hoch '+inttostr(soll3));
Interface_rauf_runter;

AP_links_oben_zurueck;



memo1.lines.add('speichere '+inttostr(Index)+' Daten');
memo1.lines.add('in Speicher.TXT');


AssignFile(f,  ExtractFilePath(Application.Exename) +'Speicher.txt');
Append(f);
writeln(f,'Roboter-Postionen (Soll1[rechts];Soll2[vor];Soll3[oben];');
for Index := 1 to 175 do
begin
Zeile1:=inttostr(Speicher[Index,1])+';';
Zeile2:=inttostr(Speicher[Index,2])+';';
Zeile3:=inttostr(Speicher[Index,3])+';';
Zeile4:=inttostr(Index)+':';
GanzeZeile:=Zeile4+Zeile1+Zeile2+Zeile3;
writeln(f,GanzeZeile);
end;
closefile(f);

memo1.lines.add('Speichern ist erl.');

end;
 
Procedure TForm1.greifestift;
var
i:Integer;{For Schleife}
begin    {M4r = zu, S8= Bewegung, S7input= Zange voll offen}

if not ftiGetInput (7) then
begin
memo1.lines.add('Zange hat zugegriffen');
Exit;
end;
ftiSetMotor(4, ftirechts);
memo1.lines.add('Zange greift Stift');
for i:=1 to 32 do begin           {so weit greift die Zange zu}
ftiWaitForChange(8, 1, 0);
end;
ftiSetMotor(4, ftiAus);
memo1.lines.add('Zange hat zugegriffen');
end;
Procedure TForm1.AP_links_oben_zurueck;      {simultan!}
var
s1,s3,s5,sch1,sch2,sch3 : Integer;
begin

s1:=0;  {Schalter Anschlag Linksdrehung des Arms}
s3:=0;  {Schalter Anschlag Hochfahren des Arms}
s5:=0;  {Schalter Anschalg Reinfahren des Arms}

sch1:=1;
sch2:=1;
sch3:=1;


repeat {links}

if ftiGetInput (1) then
   begin
   ftiSetMotor(1, ftiAus);
   S1:=1;
   if sch1=1 then memo1.lines.add('Anschlag Links');
   sch1:=0;
   end;
If s1=0 then ftiSetMotor(1, ftilinks);
 {zurck}
if ftiGetInput (3) then
   begin
   ftiSetMotor(2, ftiAus);
   S3:=1;
 if sch2=1 then memo1.lines.add('Anschlag hinten');
   sch2:=0;
   end;
If s3=0 then ftiSetMotor(2, ftilinks);
   {oben}
if ftiGetInput (5) then
   begin
   ftiSetMotor(3, ftiAus);
   S5:=1;
  if sch3=1 then  memo1.lines.add('Anschlag oben');
  sch3:=0;
   end;
If s5=0 then ftiSetMotor(3, ftilinks);

until (s5=1) and (s3=1) and (s1=1);
ist1 :=0;
soll1:=0;
ist2 :=0;
soll2:=0;
ist3 :=0;
soll3:=0;
memo1.lines.add('oben,links,zurck');

end;

Procedure TForm1.Auslesen;
var
Speicher1Zeile,Speicher2Zeile:string;
f: Textfile;
Stelle:Integer;
Index:Integer;
begin
 if not FileExists('Speicher.txt') then
 begin
 MessageDlg('Speicher.txt nicht gefunden, bitte anlegen!',mtInformation, [mbOK],0);
 exit;
 end
else
 begin
 Speicher_gelesen:=1;
memo1.lines.add(' ');
memo1.lines.add(' ');
memo1.lines.add(' ');
memo1.lines.add(' ');
memo1.lines.add(' ');
memo1.lines.add(' ');
memo1.lines.add(' ');
memo1.lines.add(' ');
memo1.lines.add(' ');
memo1.lines.add(' ');
memo1.lines.add(' ');
memo1.lines.add(' ');
memo1.lines.add(' ');
memo1.lines.add(' ');

memo1.lines.add('Lese Daten aus Speicher.txt');


Index:=0;
AssignFile(f, ExtractFilePath(Application.Exename) + 'speicher.txt');
reset(f);
Readln(f, Speicher1Zeile);   {Kopfzeile weglesen}
repeat
Inc(Index);
Readln(f, Speicher1Zeile);
Stelle:=Pos(':',Speicher1Zeile);
Speicher2Zeile:=copy(Speicher1Zeile,Stelle+1,length(Speicher1Zeile));
Stelle:=Pos(';',Speicher2Zeile);
Speicher1Zeile:=copy(Speicher2Zeile,1,Stelle-1);
s1s2s3xy[Index,1]:=strtoint(Speicher1Zeile);
Speicher1Zeile:=copy(Speicher2Zeile,Stelle+1,length(Speicher2Zeile));
Stelle:=Pos(';',Speicher1Zeile);
Speicher2Zeile:=copy(Speicher1Zeile,1,Stelle-1);
s1s2s3xy[Index,2]:=strtoint(Speicher2Zeile);
Speicher2Zeile:=copy(Speicher1Zeile,Stelle+1,length(Speicher1Zeile));
Stelle:=Pos(';',Speicher2Zeile);
Speicher1Zeile:=copy(Speicher2Zeile,1,Stelle-1);
s1s2s3xy[Index,3]:=strtoint(Speicher1Zeile);

Stelle:=Pos(';',Speicher2Zeile);
Speicher1Zeile:=copy(Speicher2Zeile,Stelle+1,length(Speicher2Zeile));
Stelle:=Pos(';',Speicher1Zeile);
Speicher2Zeile:=copy(Speicher1Zeile,1,Stelle-1);
s1s2s3xy[Index,4]:=strtoint(Speicher2Zeile);
Speicher2Zeile:=copy(Speicher1Zeile,Stelle+1,length(Speicher1Zeile));
Stelle:=Pos(';',Speicher2Zeile);
Speicher1Zeile:=copy(Speicher2Zeile,1,Stelle-1);
s1s2s3xy[Index,5]:=strtoint(Speicher1Zeile);

    

until Index > 174; {eof(f)}
closefile(f);
memo1.lines.add('Lesen beendet!');
 {(Nr:Soll1[rechts];Soll2[vor];Soll3[oben];x;y;)');  }
{s1s2s3xy : array [1..175,1..5] of Integer;}
end;
end;
 {:::::::::::::::::::::::::::::::::::::}

 {:::::::::::::::::::::::::::::::::::::}
procedure TForm1.Button15Click(Sender: TObject);
var
ab:real; {abstand}
ab1:real; {abstand speicher}
Index:integer;
sp1,sp2,sp3,sp4,sp5:Integer; {speicher Roboterposition}
BMP8: TBitmap;
begin
If InterfaceIni =0 then Interface_da;
memo1.lines.add('fahre auf Anfangsposition');
Anfangsposition;
memo1.lines.add('mache Foto');
Button1Click(Sender);  {Aufnahme}
memo1.lines.add('suche Tonne');
Button7Click(Sender);  {Vergleich}

BMP8:=TBitmap.Create;
BMP8.height:=240;          {Foto}
BMP8.width:=320;

If FileExists('c:\webcam.bmp') then
begin
BMP8.LoadFromFile('c:\webcam.bmp');

end;


{suche min. Abstand in Tabelle}
{posx,posy,s1s2s3xy(1..175,1..5}
{(Nr:Soll1[rechts];Soll2[vor];Soll3[oben];x;y;)');  }
ab1:=100; {max wert zu unterschreiten}
For index:=1 to 175 do
begin
ab:=sqrt(sqr(s1s2s3xy[Index,4]-posx)+sqr(s1s2s3xy[index,5]-posy));
if ab<ab1 then
begin
ab1:=ab;
sp1:=s1s2s3xy[Index,1];
sp2:=s1s2s3xy[Index,2];
sp3:=s1s2s3xy[Index,3];
sp4:=s1s2s3xy[Index,4];
sp5:=s1s2s3xy[Index,5];
end;

BMP8.Canvas.Pixels [s1s2s3xy[Index,4],s1s2s3xy[Index,5]]:=clgreen;
BMP8.Canvas.Pixels [s1s2s3xy[Index,4]+1,s1s2s3xy[Index,5]+1]:=clgreen;
BMP8.Canvas.Pixels [s1s2s3xy[Index,4]+1,s1s2s3xy[Index,5]]:=clgreen;
BMP8.Canvas.Pixels [s1s2s3xy[Index,4],s1s2s3xy[Index,5]+1]:=clgreen;



end;
BMP8.Canvas.Pixels [sp4,sp5]:=clred;
BMP8.Canvas.Pixels [sp4+1,sp5+1]:=clred;
BMP8.Canvas.Pixels [sp4+1,sp5]:=clred;
BMP8.Canvas.Pixels [sp4,sp5+1]:=clred;
BMP8.Canvas.Pixels [posx,posy]:=clyellow;
memo1.lines.add('Tonne gefunden (gelb)');
memo1.lines.add('vergl. Koodinaten (grn)');
memo1.lines.add('zugeord. Koodinate (rot)');



Image1.Picture.Graphic:=BMP8;

{Korrektur von rechts soll1,sp1}

if sp1 < 90 then sp1:=sp1+5;
if sp1 > 95 then sp1:=sp1-trunc((18*(sp1-95)/(165-95)));


soll1:=sp1;
memo1.lines.add('fahre rechts auf '+inttostr(soll1));
Interface_links_rechts;

soll3:=80;
memo1.lines.add('fahre runter auf '+inttostr(soll3));
Interface_rauf_runter;

soll2:=sp2;
memo1.lines.add('fahre vor auf '+inttostr(soll2));
Interface_vor_zurueck;

soll3:=sp3+70;
memo1.lines.add('fahre runter auf '+inttostr(soll3));
Interface_rauf_runter;

greifezu;

soll3:=80;
memo1.lines.add('fahre hoch auf '+inttostr(soll3));
Interface_rauf_runter;

soll1:=160;
memo1.lines.add('fahre rechts auf '+inttostr(soll1));
Interface_links_rechts;

soll2:=26;
memo1.lines.add('fahre zurck auf '+inttostr(soll2));
Interface_vor_zurueck;

soll3:=120;
memo1.lines.add('fahre runter auf '+inttostr(soll3));
Interface_rauf_runter;

Aufmachen;

soll3:=80;
memo1.lines.add('fahre hoch auf '+inttostr(soll3));
Interface_rauf_runter;

Anfangsposition;
memo1.lines.add('Job beendet!');

BMP8.free;
end;

Procedure TForm1.greifezu;
var
i:Integer;{For Schleife}
begin    {M4r = zu, S8= Bewegung, S7input= Zange voll offen}

if not ftiGetInput (7) then
begin
memo1.lines.add('Zange hat zugegriffen');
Exit;
end;
ftiSetMotor(4, ftirechts);
memo1.lines.add('Zange greift zu');
for i:=1 to 27 do begin           {so weit greift die Zange zu}
ftiWaitForChange(8, 1, 0);{S8, 0..30(25 Tonne),0 = Bew. bei S7 n.geschaltet}
end;
ftiSetMotor(4, ftiAus);
memo1.lines.add('Zange hat zugegriffen');
end;


end.
